boxdrawdata:
;Data Format:

;byte1=Xpos byte2=Ypos byte3=width byte4=height

;All labels here starts with a "BDD_" to avoid label confusion with main program.
;Additional lookup table may be used. All is multiplied by 4 if more than 64 boxes.
; If not, then the multiplication may be done when writing the table (or, may generate one)
;
DrawMainMenu: drawbox(BDD_mainBox) \ drawbox(BDD_orbBox) \ ret
DrawNameBox: drawbox(BDD_nameSelectBo) \ ret
DrawItemMenu: drawbox(BDD_itemTitleBox) \ drawbox(BDD_NSSelectbox) \ drawbox(BDD_Itembox) \ ret
DrawStatusMenu: drawbox(BDD_NameLVBOX) \ drawbox(BDD_ClassBox) \ drawbox(BDD_StatusBox) \ drawbox(BDD_if12x16) \ ret
DrawWeaponMenu: drawbox(BDD_IfWeaponBox) \ jr DrawCommonBox 
DrawArmorMenu: drawbox(BDD_IfArmorBox) \ jr DrawCommonBox
DrawCommonBox: drawbox(BDD_NameClassBox) \ drawbox(BDD_OnHandBox) \ drawbox(BDD_OptionExchangeBox) \ ret
DrawMagicMenu: drawbox(BDD_MagicTitleBox) \ drawbox(BDD_NameChangeClassBox) \ drawbox(BDD_SpellBox) \ ret
;this section is buggy somewhat.
rMainMenu: rbox(BDD_mainBox) \ rbox(BDD_orbBox) \ ret
rNameBox: rbox(BDD_nameSelectBo) \ ret
rItemMenu: rbox(BDD_itemTitleBox) \ rbox(BDD_NSSelectbox) \ rbox(BDD_Itembox) \ ret
rStatusMenu: rbox(BDD_NameLVBOX) \ rbox(BDD_ClassBox) \ rbox(BDD_StatusBox) \ rbox(BDD_if12x16) \ ret
rWeaponMenu: rbox(BDD_IfWeaponBox) \ jr rCommonBox 
rArmorMenu: rbox(BDD_IfArmorBox) \ jr rCommonBox
rCommonBox: rbox(BDD_NameClassBox) \ rbox(BDD_OnHandBox) \ rbox(BDD_OptionExchanBox) \ ret
rMagicMenu: rbox(BDD_MagicTitleBox) \ rbox(BDD_NameChangeClassBox) \ rbox(BDD_SpellBox) \ ret

BDD_InitializePointers:
 push af \ ld e,(hl) \ inc hl \ ld d,(hl) \ inc hl \ ld a,(hl) \ inc hl \ ld h,(hl) \ ld L,a \ pop af \ ret
BDD_Lbl01a: push hl \ call BDD_InitializePointers \ call DB_StoreData \ call DB_PreserveData \ pop hl 
 call BDD_InitializePointers \ call DB_StoreData \ call DB_drawBox \ ret 

;MAINMENU
BDD_mainBox:		.db 00,01,26,32
.db "ITEMS",$06,"STATUS",$06
.db "MAGIC",$06,"WEAPON",$06
.db "ARMOR",$FF
BDD_orbBox:		.db 00,33,20,20
BDD_nameSelectBo:	.db 27,00,62,54
.db  ;Input the data table for the persons involved. And the data for the persons.
.db  ;All entries are "tokens" from this data table, and nothing is constant
.db  ;save for the slash marks and the colons (which are constant)

;ITEMS
BDD_itemTitleBox:	.db 32,01,58,08
BDD_NSSelectbox:	.db 32,09,58,08
BDD_Itembox:		.db 24,19,70,29
;STATUS
BDD_NameLVBOX:		.db 39,01,54,08
BDD_ClassBox:		.db 40,09,38,14
BDD_StatusBox:		.db 07,26,88,26
BDD_if12x16:		.db 22,02,15,19
BDD_if16x16:		.db 18,02,19,19
BDD_if16x24:		.db 18,00,19,25
BDD_if24x24:		.db 12,00,25,25
;WPN/AMR
BDD_IfWeaponBox:	.db 47,00,26,08
BDD_IfArmorBox:		.db 49,00,22,08
BDD_NameClassBox:	.db 28,08,66,08
BDD_OnHandBox:		.db 11,16,41,36
BDD_OptionExchaneBox:	.db 54,18,41,36
;MAGIC
BDD_MagicTitleBo:	.db 00,00,32,08
BDD_NameChangeClssBox:	.db 24,00,70,08
BDD_SpellBox:		.db 17,10,78,50
;===============================================================
;===============================================================
;===============================================================
DB_boxcoords	equ	appBackUpScreen+280
DB_hw		equ	appBackUpScreen+282
DB_width	equ	appBackUpScreen+282
DB_height	equ	appBackUpScreen+283
DB_address	equ	appBackUpScreen+284
DB_drawrite	equ	appBackUpScreen+286
DB_drawskip	equ	appBackUpScreen+287
DB_startbit	equ	appBackUpScreen+288
DB_endbit	equ	appBackUpScreen+289
DB_temp1	equ	appBackUpScreen+290
DB_temp2	equ	appBackUpScreen+292
DB_temp3	equ	appBackUpScreen+294
DB_drawstack	equ	appBackUpScreen+296
DB_stackaddress	equ	appBackUpScreen+298 ;DB_address of the stack being processed.
DB_RAMpage	equ	appBackUpScreen+300
DB_AtextFlag	equ	appBackUpScreen+302
DB_startbitfill	equ	appBackUpScreen+304 ;this mask used to erase excess data on edge of border. (or keep the needed data)
DB_endbitfill	equ	appBackUpScreen+305
DB_smallstack	equ	Op2              ;the stack DB_address just for the loop. Stack does not need to be that big...
;Program Arguments:
; DE=DB_boxcoordsinates. D=Y, E=X
; HL=DB_width/DB_height.   H=H, L=W
; BC=pointer         BC=pointertoperservebuffer. Writes forwards. Reads backwards.
;  A=Flags.          TBD.
;Output:
;  BC=DB_address of the new "stack" position.
DB_StoreData:  ;Drawstack is initialize at start of the program. Mainly, when everything's initialized.
 ld (DB_hw),hl
 ld (DB_boxcoords),de
 ld (DB_AtextFlag),a
 ret
DB_preservedata: ;====================================================================================================
 call DB_calculatedata  ;change to LBL01 when done...
 call DB_initiateStack
 in a,(5) \ ld (DB_RAMpage),a
 ld a,7 \ out (5),a
 ld de,(DB_drawstack)
 ld hl,(DB_address)
 ld a,(DB_height) \ ld b,a
DB_preserveMainLoop:
 push bc
  ld a,(DB_drawrite) \ ld b,a
DB_preserve1stLoop:
  ld a,(hl) \ ld (de),a
  inc hl \ dec de
  djnz DB_preserve1stLoop
  ld a,(DB_drawskip) \ or a
  jr z,DB_skippreserve2ndLoop \ ld b,a
DB_preserve2ndLoop:
  inc hl \ djnz DB_preserve2ndLoop
DB_skippreserve2ndLoop:
 pop bc
 djnz DB_preserveMainLoop
 ex de,hl  ;after this, HL=stack position, DE=drawpointer.
 ld (hl),d \ dec hl
 ld (hl),e \ dec hl ;Drawing pos
 ld de,(DB_hw)
 ld (hl),d \ dec hl
 ld (hl),e \ dec hl  ;DB_height, DB_width
 ld de,(DB_boxcoords)
 ld (hl),d \ dec hl ;box coordinates and
 ld (hl),e \ dec hl ;pushing the values on the "stack".
 ld (DB_drawstack),hl
 ld a,(DB_RAMpage)
 out (5),a \ call DB_restoreStack \ ret
DB_restoredata: ;====================================================================================================
 call DB_initiatestack \ in a,(5)
 ld (DB_RAMpage),a \ ld a,7
 out (5),a \ ld hl,(DB_drawstack)
 inc hl \ ld e,(hl)
 inc hl \ ld d,(hl)
 inc hl \ ld c,(hl)
 inc hl \ ld b,(hl)
 ld (DB_boxcoords),de
 ld (DB_hw),bc
 push hl
  call DB_calculatedata   ;change to LBL01 when done...
 pop hl \ inc hl \ ld e,(hl)
 inc hl \ ld d,(hl) \ dec de
 ld a,(DB_height) \ ld b,a
DB_restoremainloop:
 push bc
  ld a,(DB_drawskip) \  or a
  jr z,DB_restorenoskip \ ld b,a
DB_restore2ndLoop:
  dec de \ djnz DB_restore2ndLoop
DB_restorenoskip:
  ld a,(DB_drawrite) \ ld b,a
DB_restore1stloop:
  inc hl \  ld a,(hl)
  ld (de),a \  dec de
  djnz DB_restore1stloop
 pop bc \ djnz DB_restoremainloop
 ld (DB_drawstack),hl
 ld a,(DB_RAMpage)
 out (5),a \ call DB_restorestack
 ret
DB_initiatestack:  ;Popping then pushing to get and save the value of the return statement after SP is moved.
 pop hl \ push hl
 ld (DB_stackaddress),SP
 ld SP,DB_smallstack
 push hl \ ret
DB_drawBox: ;====================================================================================================
 call DB_calculatedata  ;change to LBL01 when done...
 ld de,(DB_drawstack)
 ld hl,(DB_address)
 ld a,(DB_height)
 ld b,a
DB_dbmainloop:
 push bc \ ld a,(DB_drawrite) 
  ld b,a \ ld a,(DB_startbitfill)
  ld c,(hl) \ cpl
  and c \ ld c,a
  ld a,(DB_startbit)
  or c \ ld (hl),c
  ld a,b \ or a
  jr z,DB_dbnoincfill
  inc hl \ dec b
  jr z,DB_dbnoincfill
  dec b    ;to stop eraseLoop early so that last few bits is preserved for partial erasing.
DB_dbsuberaseloop:
  ld (hl),$00 \ inc hl
  djnz DB_dbsuberaseloop
DB_dbnoincfill:
  ld a,(DB_endbitfill)
  ld c,(hl) \ cpl \ and c
  ld c,a \ ld a,(DB_endbit)
  or c \ ld (hl),c
  inc hl \ ld a,(DB_drawskip)
  or a \ jr z,DB_dbskipskip
  ld b,a
DB_dbskip: inc hl \ djnz DB_dbskip
DB_dbskipskip: pop bc \ djnz DB_dbmainloop \ ret
DB_restorestack: ld SP,(DB_stackaddress) \ ret
DB_calculatedata: ld hl,(DB_boxcoords)
 call DB_lbl01 \ inc de \ add hl,de
 ld de,plotsscreen \ add hl,de 
 ld (DB_address),hl \ ld hl,(DB_boxcoords)
 ld a,(DB_width) \ add a,L 
 call DB_lbl02 \ ld (DB_endbit),a
 ld (DB_temp1),de
 ld hl,(DB_boxcoords)
 ld a,L \ call DB_lbl02
 ld (DB_startbit),a
 ld hl,(DB_boxcoords)
 ld a,(DB_width)
 add a,l \ ld L,a
 ld a,95 \ sub L
 call DB_lbl02
 ld a,e \ ld (DB_drawskip),a
 ld e,a \ ld a,12
 sub e \ ld (DB_drawrite),a
 ld a,(DB_startbit)
 ld b,8 \ ld c,a
DB_DB_startbitcalcloop:
 srl a \ or c
 djnz DB_DB_startbitcalcloop
 ld (DB_startbitfill),a
 ld a,(DB_endbit)
 ld b,8 \ ld c,a
DB_DB_endbitcalcloop:
 sla a \ or c
 djnz DB_DB_endbitcalcloop
 ld (DB_endbitfill),a \ ret
DB_lbl01:
 ld h,$0 \ add hl,hl
 add hl,hl \ ld d,h
 ld e,l \ add hl,hl
 add hl,de
DB_lbl02: ld e,a \ xor a \ ld d,a \ srl e \ rra
 srl e \ rra \ srl e \ rra \ rlca \ rlca \ rlca \ ret